C     Last change:  T    13 Jul 2004   11:44 am
      CHARACTER*8 METFL(5)
      CHARACTER*9 EMMFL(5)
      CHARACTER*10 DUM,dum2
      INTEGER APP
      REAL B0(24),B1(24),B2(24),B3(24)
      DATA METFL/'MET1.RAN','MET2.RAN','MET3.RAN','MET4.RAN','MET5.RAN'/
      DATA EMMFL/'YEAR1.EMM','YEAR2.EMM','YEAR3.EMM','YEAR4.EMM',
     X           'YEAR5.EMM'/

** READ IN THE SPSS CALCULATED CUBIC PARAMETERS FOR ALL 24 PERIODS **

      OPEN (5,FILE='spss.DAT',STATUS='OLD')
      OPEN (6,FILE='app.DAT',STATUS='OLD')

      READ(6,'(I4)') APP

      CLOSE(6)

      DO I=1,24

        READ(5,'(4F12.7)') B0(I),B1(I),B2(I),B3(I)

      END DO

      CLOSE(5)

** START EMISSIONS AT PERIOD 24 **

      NPER=23
      NHR=2

      CALL RANDOM_SEED

** CYCLE THROUGH FIVE YEARS OF MET DATA **

      DO NY=1,5

        OPEN(5,FILE=METFL(NY),STATUS='OLD')
        READ(5,'(A10)') DUM
        OPEN(6,FILE=EMMFL(NY),STATUS='UNKNOWN')

        DO NH=1,8785

          READ(5,'(4I2)',END=10) IY,IM,ID,IH

** RANDOMIZE EMISSION RATE FOR EVERY HOUR **

          NHR=NHR+1

          IF (NHR.EQ.5) THEN

            NPER=NPER+1
            IF (NPER.GT.24) NPER=1
            NHR=1

          END IF

          CALL RANDOM_NUMBER(X)

          RAND=X*95.0+2.5

          EMM=B0(NPER)+B1(NPER)*RAND+B2(NPER)*RAND**2+B3(NPER)*RAND**3

          EMM=EMM*APP*.01*1E-06

** WRITE OUT HOURLY SURFACE DATA WITH RANDOMIZED WIND VECTORS **

          IF (NHR.EQ.4) THEN

          WRITE(6,'(A13,4I5,A10,F11.8,I5)') 'SO HOUREMIS ',IY,IM,ID,IH,
     X                                       ' SOURCE1 ', EMM, NPER
          ELSE

            WRITE(6,'(A13,4I5,A10,F11.8)') 'SO HOUREMIS ',IY,IM,ID,IH,
     X                                    ' SOURCE1 ', EMM
          END IF

   10   END DO

      CLOSE(5)
      CLOSE(6)

      END DO

      STOP
      END
