C     Last change:  MTH  15 Jan 2004    1:50 pm
C     This program sets up the Sensitivity Analysis for the Exposure Assessment Program

      CHARACTER*75 DUM
      INTEGER Em, Ws, Wd, Is, Indoor, A

      OPEN(20,FILE='RANDOM.BAT',STATUS='UNKNOWN')
      OPEN(21,FILE='RANDOM.BAS',STATUS='OLD')
      OPEN(22,FILE='DATA.DAT',STATUS='OLD')

      A=0

      READ(22,'(A75)') DUM
      READ(22,'(A75)') DUM
      READ(22,'(I4)') Em
      READ(22,'(I4)') Ws
      READ(22,'(I4)') Wd
      READ(22,'(I4)') Is
      READ(22,'(I4)') Indoor

      IF (Indoor.EQ.3) THEN
        OPEN(30,FILE='Ind.txt',STATUS='UNKNOWN')
        WRITE(30,'(I5)') A
        CLOSE(30)
      END IF

C     Emissions, Wind Speed, Wind Direction, and Stability are Not Randomized 0000

      IF (Em.EQ.0.AND.Ws.EQ.0.AND.Wd.EQ.0.AND.Is.EQ.0) THEN
        DO I=1,7
          READ(21,'(A75)') DUM
          WRITE(20,'(A75)') DUM
        END DO
        READ(21,'(A2)') DUM
        WRITE(20,'(A2)') 'WS'
        DO I=1,4
          READ(21,'(A75)') DUM
          WRITE(20,'(A75)') DUM
        END DO
        READ(21,'(A2)') DUM
        WRITE(20,'(A4)') 'WVIS'
        DO I=1,5
          READ(21,'(A75)') DUM
          WRITE(20,'(A75)') DUM
        END DO
        READ(21,'(A75)') DUM
        WRITE(20,'(A8)') 'CALL EM2'
        DO J=1,100
          READ(21,'(A75)', END=20) DUM
          WRITE(20,'(A75)') DUM
        END DO

C     Emissions, Wind Speed, and Wind Direction are Not Randomized 0001

      ELSE IF (Em.EQ.0.AND.Ws.EQ.0.AND.Wd.EQ.0.AND.Is.EQ.1) THEN
        DO I=1,7
          READ(21,'(A75)') DUM
          WRITE(20,'(A75)') DUM
        END DO
        READ(21,'(A2)') DUM
        WRITE(20,'(A2)') 'WS'
        DO I=1,4
          READ(21,'(A75)') DUM
          WRITE(20,'(A75)') DUM
        END DO
        READ(21,'(A2)') DUM
        WRITE(20,'(A2)') 'WV'
        DO I=1,5
          READ(21,'(A75)') DUM
          WRITE(20,'(A75)') DUM
        END DO
        READ(21,'(A75)') DUM
        WRITE(20,'(A8)') 'CALL EM2'
        DO J=1,100
          READ(21,'(A75)', END=20) DUM
          WRITE(20,'(A75)') DUM
        END DO

C     Emissions, Wind Speed, and Stability are Not Randomized 0010

      ELSE IF (Em.EQ.0.AND.Ws.EQ.0.AND.Wd.EQ.1.AND.Is.EQ.0) THEN
        DO I=1,7
          READ(21,'(A75)') DUM
          WRITE(20,'(A75)') DUM
        END DO
        READ(21,'(A2)') DUM
        WRITE(20,'(A2)') 'WS'
        DO I=1,4
          READ(21,'(A75)') DUM
          WRITE(20,'(A75)') DUM
        END DO
        READ(21,'(A2)') DUM
        WRITE(20,'(A2)') 'IS'
        DO I=1,5
          READ(21,'(A75)') DUM
          WRITE(20,'(A75)') DUM
        END DO
        READ(21,'(A75)') DUM
        WRITE(20,'(A8)') 'CALL EM2'
        DO J=1,100
          READ(21,'(A75)', END=20) DUM
          WRITE(20,'(A75)') DUM
        END DO

C     Emissions and Wind Speed are Not Randomized 0011

      ELSE IF (Em.EQ.0.AND.Ws.EQ.0.AND.Wd.EQ.1.AND.Is.EQ.1) THEN
        DO I=1,7
          READ(21,'(A75)') DUM
          WRITE(20,'(A75)') DUM
        END DO
        READ(21,'(A2)') DUM
        WRITE(20,'(A2)') 'WS'
        DO I=1,10
          READ(21,'(A75)') DUM
          WRITE(20,'(A75)') DUM
        END DO
        READ(21,'(A75)') DUM
        WRITE(20,'(A8)') 'CALL EM2'
        DO J=1,100
          READ(21,'(A75)', END=20) DUM
          WRITE(20,'(A75)') DUM
        END DO

C     Emissions, Wind Direction, and Stability are Not Randomized 0100

      ELSE IF (Em.EQ.0.AND.Ws.EQ.1.AND.Wd.EQ.0.AND.Is.EQ.0) THEN
        DO I=1,12
          READ(21,'(A75)') DUM
          WRITE(20,'(A75)') DUM
        END DO
        READ(21,'(A2)') DUM
        WRITE(20,'(A4)') 'WVIS'
        DO I=1,5
          READ(21,'(A75)') DUM
          WRITE(20,'(A75)') DUM
        END DO
        READ(21,'(A75)') DUM
        WRITE(20,'(A8)') 'CALL EM2'
        DO J=1,100
          READ(21,'(A75)', END=20) DUM
          WRITE(20,'(A75)') DUM
        END DO

C     Emissions and Wind Direction are Not Randomized 0101

      ELSE IF (Em.EQ.0.AND.Ws.EQ.1.AND.Wd.EQ.0.AND.Is.EQ.1) THEN
        DO I=1,12
          READ(21,'(A75)') DUM
          WRITE(20,'(A75)') DUM
        END DO
        READ(21,'(A2)') DUM
        WRITE(20,'(A2)') 'WV'
        DO I=1,5
          READ(21,'(A75)') DUM
          WRITE(20,'(A75)') DUM
        END DO
        READ(21,'(A75)') DUM
        WRITE(20,'(A8)') 'CALL EM2'
        DO J=1,100
          READ(21,'(A75)', END=20) DUM
          WRITE(20,'(A75)') DUM
        END DO

C     Emissions and Stability are Not Randomized 0110

      ELSE IF (Em.EQ.0.AND.Ws.EQ.1.AND.Wd.EQ.1.AND.Is.EQ.0) THEN
        DO I=1,12
          READ(21,'(A75)') DUM
          WRITE(20,'(A75)') DUM
        END DO
        READ(21,'(A2)') DUM
        WRITE(20,'(A2)') 'IS'
        DO I=1,5
          READ(21,'(A75)') DUM
          WRITE(20,'(A75)') DUM
        END DO
        READ(21,'(A75)') DUM
        WRITE(20,'(A8)') 'CALL EM2'
        DO J=1,100
          READ(21,'(A75)', END=20) DUM
          WRITE(20,'(A75)') DUM
        END DO

C     Emissions are Not Randomized 0111

      ELSE IF (Em.EQ.0.AND.Ws.EQ.1.AND.Wd.EQ.1.AND.Is.EQ.1) THEN
        DO I=1,18
          READ(21,'(A75)') DUM
          WRITE(20,'(A75)') DUM
        END DO
        READ(21,'(A75)') DUM
        WRITE(20,'(A8)') 'CALL EM2'
        DO J=1,100
          READ(21,'(A75)', END=20) DUM
          WRITE(20,'(A75)') DUM
        END DO

C     Wind Direction, Stability, and Wind Speed are Not Randomized 1000

      ELSE IF (Em.EQ.1.AND.Ws.EQ.0.AND.Wd.EQ.0.AND.IS.EQ.0) THEN

        DO I=1,7
          READ(21,'(A75)') DUM
          WRITE(20,'(A75)') DUM
        END DO
        READ(21,'(A2)') DUM
        WRITE(20,'(A2)') 'WS'
        DO I=1,4
          READ(21,'(A75)') DUM
          WRITE(20,'(A75)') DUM
        END DO
        READ(21,'(A2)') DUM
        WRITE(20,'(A4)') 'WVIS'
        DO J=1,100
          READ(21,'(A75)', END=20) DUM
          WRITE(20,'(A75)') DUM
        END DO

C     Wind Direction and Wind Speed are Not Randomized 1001

      ELSE IF (Em.EQ.1.AND.Ws.EQ.0.AND.Wd.EQ.0.AND.IS.EQ.1) THEN

        DO I=1,7
          READ(21,'(A75)') DUM
          WRITE(20,'(A75)') DUM
        END DO
        READ(21,'(A2)') DUM
        WRITE(20,'(A2)') 'WS'
        DO I=1,4
          READ(21,'(A75)') DUM
          WRITE(20,'(A75)') DUM
        END DO
        READ(21,'(A2)') DUM
        WRITE(20,'(A2)') 'WV'
        DO J=1,100
          READ(21,'(A75)', END=20) DUM
          WRITE(20,'(A75)') DUM
        END DO

C     Wind Speed and Stability are Not Randomized 1010

      ELSE IF (Em.EQ.1.AND.Ws.EQ.0.AND.Wd.EQ.1.AND.IS.EQ.0) THEN

        DO I=1,7
          READ(21,'(A75)') DUM
          WRITE(20,'(A75)') DUM
        END DO
        READ(21,'(A2)') DUM
        WRITE(20,'(A2)') 'WS'
        DO I=1,4
          READ(21,'(A75)') DUM
          WRITE(20,'(A75)') DUM
        END DO
        READ(21,'(A2)') DUM
        WRITE(20,'(A2)') 'IS'
        DO J=1,100
          READ(21,'(A75)', END=20) DUM
          WRITE(20,'(A75)') DUM
        END DO

C     Wind Speed is Not Randomized 1011

      ELSE IF (Em.EQ.1.AND.Ws.EQ.0.AND.Wd.EQ.1.AND.IS.EQ.1) THEN

        DO I=1,7
          READ(21,'(A75)') DUM
          WRITE(20,'(A75)') DUM
        END DO
        READ(21,'(A2)') DUM
        WRITE(20,'(A2)') 'WS'
        DO J=1,100
          READ(21,'(A75)', END=20) DUM
          WRITE(20,'(A75)') DUM
        END DO

C     Wind Direction and Stability are Not Randomized 1100

      ELSE IF (Em.EQ.1.AND.Ws.EQ.1.AND.Wd.EQ.0.AND.IS.EQ.0) THEN

        DO I=1,12
          READ(21,'(A75)') DUM
          WRITE(20,'(A75)') DUM
        END DO
        READ(21,'(A2)') DUM
        WRITE(20,'(A4)') 'WVIS'
        DO J=1,100
          READ(21,'(A75)', END=20) DUM
          WRITE(20,'(A75)') DUM
        END DO

C     Wind Direction is Not Randomized 1101

      ELSE IF (Em.EQ.1.AND.Ws.EQ.1.AND.Wd.EQ.0.AND.Is.EQ.1) THEN

        DO I=1,12
          READ(21,'(A75)') DUM
          WRITE(20,'(A75)') DUM
        END DO
        READ(21,'(A2)') DUM
        WRITE(20,'(A2)') 'WV'
        DO J=1,100
          READ(21,'(A75)', END=20) DUM
          WRITE(20,'(A75)') DUM
        END DO

C     Stability is Not Randomized 1110

      ELSE IF (Em.EQ.1.AND.Ws.EQ.1.AND.Wd.EQ.1.AND.Is.EQ.0) THEN

        DO I=1,12
          READ(21,'(A75)') DUM
          WRITE(20,'(A75)') DUM
        END DO
        READ(21,'(A2)') DUM
        WRITE(20,'(A2)') 'IS'
        DO J=1,100
          READ(21,'(A75)', END=20) DUM
          WRITE(20,'(A75)') DUM
        END DO

C     Everything is Randomized 1111

      ELSE IF (Em.EQ.1.AND.Ws.EQ.1.AND.Wd.EQ.1.AND.Is.EQ.1) THEN

        DO J=1,100
          READ(21,'(A75)', END=20) DUM
          WRITE(20,'(A75)') DUM
        END DO

   20 END IF

      OPEN(23,FILE='Ind.bat',STATUS='UNKNOWN')

      IF(Indoor.EQ.0) THEN
        WRITE(23,*) '                         '
      ELSE IF (Indoor.LT.3) THEN
        WRITE(23,'(A15)') 'CALL Indoor.bat'
      ELSE
        WRITE(23,'(A6)') 'INDPER'
        WRITE(23,'(A11)') 'DEL IND.TXT'
        WRITE(23,'(A23)') 'RENAME IND2.TXT IND.TXT'
        WRITE(23,'(A19)') 'PKZIP TOX.ZIP *.TOX'
        WRITE(23,'(A15)') 'CALL Indoor.bat'
        WRITE(23,'(A25)') 'RENAME BUFF.OUT BUFF2.OUT'
        WRITE(23,'(A6)') 'INDPER'
        WRITE(23,'(A11)') 'DEL IND.TXT'
        WRITE(23,'(A23)') 'RENAME IND2.TXT IND.TXT'
        WRITE(23,'(A9)') 'DEL *.TOX'
        WRITE(23,'(A15)') 'PKUNZIP TOX.ZIP'
        WRITE(23,'(A15)') 'CALL Indoor.bat'
      END IF

      CLOSE (20)
      CLOSE (21)
      CLOSE (22)
      CLOSE (23)

      STOP
      END
