C     Last change:  MTH   2 Jan 2004    4:13 pm
      CHARACTER*80 DUM
      REAL k,Conc,Ci,Coi,Co,b1,b2,CONC2,XX,YY,Co2,NR
      INTEGER Indoor,Hour,Receptor,NH,ND,R,O,NI,A,H,T,Hour2,NRI
      DIMENSION CONC2(720),XX(720),YY(720),Coi(720),Ci(720)

      OPEN(1,FILE='data.dat',STATUS='OLD')
      OPEN(2,FILE='check.txt',STATUS='OLD')
      OPEN(3,FILE='tox.txt',STATUS='UNKNOWN')
      OPEN(4,FILE='post.txt',STATUS='OLD')

      READ(1,'(A80)') DUM
      READ(1,'(A80)') DUM
      DO Z=1,4
        READ(1,'(A80)') DUM
      END DO
      READ(1,'(I4)') Indoor

      IF (Indoor.EQ.3) THEN
         OPEN(5,FILE='Ind.txt',STATUS='OLD')
         READ(5,'(I5)') A
         IF (A.EQ.1) THEN
            Indoor=1
         ELSE IF (A.EQ.2) THEN
            Indoor=2
         END IF
         CLOSE(5)
      END IF

      CLOSE(1)
      CLOSE(5)

** SET k TO 0.65 **

      k=0.65

** INITIALIZE INDOOR CONCENTRATION (Ci) TO BACKGROUND LEVELS FOR FIRST HOUR **

      Ci=0.000001
      Coi=0.000001
      O=0
      Co=0
      H=0
      Hour2=0

      CALL RANDOM_SEED

** SKIP FIRST 8 LINES OF POSTFILE AND WRITE OUT FIRST 6 LINES OF TOXFILE **

      DO NL=1,6
        READ(2,'(A80)') DUM
        WRITE(3,'(A80)') DUM
      END DO

      DO NL=1,8
        READ(4,'(A80)') DUM
      END DO

** BEGIN MAJOR LOOP AROUND HOURS

      WRITE(*,*) 'BEGINNING HOURLY ADJUSTMENT OF TOX FILE'
      WRITE(*,*) ' '
      WRITE(*,*) ' '

      DO ND=1,8784

       T=0
       IF (ND.EQ.88) THEN
          WRITE(*,*) '1% Complete'
        ELSE IF (ND.EQ.175) THEN
          WRITE(*,*) '2% Complete'
        ELSE IF (ND.EQ.438) THEN
          WRITE(*,*) '5% Complete'
        ELSE IF (ND.EQ.876) THEN
          WRITE(*,*) '10% Complete'
        ELSE IF (ND.EQ.2190) THEN
          WRITE(*,*) '25% Complete'
        ELSE IF (ND.EQ.4380) THEN
          WRITE(*,*) '50% Complete'
        ELSE IF (ND.EQ.6570) THEN
          WRITE(*,*) '75% Complete'
        ELSE IF (ND.EQ.7884) THEN
          WRITE(*,*) '90% Complete'
        ELSE IF (ND.EQ.8322) THEN
          WRITE(*,*) '95% Complete'
        ELSE IF (ND.EQ.8585) THEN
          WRITE(*,*) '98% Complete'
        ELSE IF (ND.EQ.8672) THEN
          WRITE(*,*) '99% Complete'
        END IF

        DO Z=1,720
          CONC2(Z)=0
          IF (ND.EQ.1) THEN
            READ(4,'(T4,F10.5,T18,F10.5)',END=20) XX(Z),YY(Z)
            Coi(Z)=0.000001
            Ci(Z)=0
          END IF
        END DO

** READ IN THE OUTDOOR (AMBIENT) CONCENTRATION **

    5   IF (O.NE.1.AND.H.NE.1) THEN
          READ(2,'(T7,I6,T22,I3,T61,F12.7)',END=7)
     x      Hour, Receptor, Co
        ELSE IF (H.NE.1) THEN
          CONC2(Receptor)=Co2
        END IF

        IF (Hour.EQ.ND.AND.H.NE.1) THEN
          CONC2(Receptor)=Co
          O=0
          GOTO 5
        ELSE IF (H.NE.1) THEN
          IF (T.NE.1) THEN
            T=1
            Hour2=Hour2+1
          END IF
          Co2=Co
          O=1
        END IF

        GOTO 10

   7    H=1
        IF (ND.LE.8760) THEN
          IF (ND.EQ.8760) THEN
            GOTO 20
          END IF
        END IF

** BEGIN MAJOR LOOP AROUND RECEPTORS

   10   DO R=1,720

** SET OPEN OR CLOSED WINDOWS DEPENDING ON SEASON AND PROBABILITY **

          CALL RANDOM_NUMBER(X)

          NI=INT(ND/24)
          NR=ND/24
          NRI=NINT(NR-NI)*24

***   Winter Calculation for Open Window ***

          IF (NI.LT.61.OR.NI.GT.335) THEN

***   Nightime Calculation in Winter ***

            IF (NRI.LT.8.OR.NRI.GT.16) THEN
              Am=1.0

***   Daytime Calculation in Winter ***

            ELSE
              IF (X.LE.0.01) THEN
                Am=2.4
              ELSE
                Am=1.0
              END IF
            END IF

***   Spring/Summer/Fall Calculation for Open Window ***

          ELSE

***   Nightime Calculation in Spring/Summer/Fall Season ***

            IF (NRI.LT.6.OR.NRI.GT.18) THEN
              IF (X.LE.0.10) THEN
                Am=2.4
              ELSE
                Am=1.0
              END IF

***   Daytime Calculation in Spring/Summer/Fall Season ***

            ELSE
              IF (X.LE.0.20) THEN
                Am=2.4
              ELSE
                Am=1.0
              END IF
            END IF
          END IF

** CALCULATE THE INDOOR CONCENTRATIONS FOR EACH RECEPTOR **
** CALCULATE CHANGE IN INDOOR CONCENTRATION **

          b1=k*am
          Co=CONC2(R)+0.000001
          Ci(R)=((2-b1)/(2+b1))*Ci(R)+((2*b1)/(2+b1))*(Coi(R)+Co)/2
          Coi(R)=Co

** CALL RANDUM NUMBER FOR PROBABILITY OF INDOOR VS. OUTDOOR

          CALL RANDOM_NUMBER(X)


          NH=ND-24*(INT(ND/24))

***   For Winter ***

          IF (NI.LT.61.OR.NI.GT.335) THEN

** PEOPLE ARE INSIDE 87% OF THE TIME FROM 7 A.M. TO 11 P.M. **
** OUTSIDE NEARBY 6%, and OUTSIDE FAR AWAY 7% **

            IF(NH .GE. 7 .AND. NH .LE. 23) THEN
              IF(X .LE. 0.89) THEN
                CONC=Ci(R)
              ELSE IF (X.GT.0.89.AND.X.LT.0.99) THEN
                CONC=0.000001
              ELSE
                CONC=Co
              END IF

** AND INSIDE 100% OF THE TIME FROM MIDNIGHT TO 6 A.M. **

            ELSE
              CONC=Ci(R)
            END IF

***   For Spring/Summer/Fall ***

          ELSE

            IF(NH .GE. 7 .AND. NH .LE. 23) THEN
              IF(X .LE. 0.87) THEN
                CONC=Ci(R)
              ELSE IF (X.GT.0.87.AND.X.LT.0.97) THEN
                CONC=0.000001
              ELSE
                CONC=Co
              END IF

** AND INSIDE 99% OF THE TIME FROM MIDNIGHT TO 6 A.M. **

            ELSE
              IF(X .LE. 0.99) THEN
                CONC=Ci(R)
              ELSE
                CONC=Co
              END IF
            END IF

          END IF

** OUTPUT FILES SHOWING HOURLY OUTDOOR/INDOOR CONCENTRATIONS **

          IF (Indoor.EQ.1) THEN
            IF (Ci(R).GT.0.000001) THEN
              WRITE(3,'(T7,I6,T22,I3,T29,F12.6,T45,F12.6,T61,F12.7)')ND,
     x             R, XX(R), YY(R), Ci(R)
            END IF
          ELSE IF (Indoor.EQ.2) THEN
            IF (CONC.GT.0.000001) THEN
              WRITE(3,'(T7,I6,T22,I3,T29,F12.6,T45,F12.6,T61,F12.7)')ND,
     x             R, XX(R), YY(R), CONC
            END IF
          END IF

        END DO
      END DO

   20 WRITE(*,*) ' '
      WRITE(*,*) ' '
      WRITE(*,*) 'Processed ',Hour2,' hours with at least 1 receptor'
      WRITE(*,*) 'having a value over 1 ug/m3 out of the 720 receptor'
      WRITE(*,*) 'grid based on concentration data from the ISCST3 TOX'
      WRITE(*,*) 'output file.'
      WRITE(*,*) 'Completed ',ND,' hours in analysis.  Moving on to'
      WRITE(*,*) 'the following year.'
      WRITE(*,*) ' '

      CLOSE(4)
      CLOSE(2)
      CLOSE(3)
      STOP
      END
