C     Last change:  MTH  16 Jan 2004   10:41 am
***   This program randomizes the meteorological data by cutting out one year from
***   a five-year dataset based on a randomized day in the dataset

      CHARACTER*72 METDATA(2000,24),DUM(35)
      CHARACTER*9 DUM2(2000,24)
      INTEGER DY,D1,DD,D2,YDY(35)

***   Metdata is the name of the text representing one hour of meteorlogical data
***   DUM is used as temporary storage for data

      OPEN(31,FILE='YEAR1.MET',STATUS='OLD')
      OPEN(32,FILE='YEAR2.MET',STATUS='OLD')
      OPEN(33,FILE='YEAR3.MET',STATUS='OLD')
      OPEN(34,FILE='YEAR4.MET',STATUS='OLD')
      OPEN(35,FILE='YEAR5.MET',STATUS='OLD')

***   Set ND, total number of Days, to zero

      ND=1

***   This loop opens and processes five yearly meteorological files

      DO NY=31,35

        READ(NY,'(A72)') DUM(NY)

***   Read in the Meteorological Data for One Year

        DO DY=1,367

          DO H=1,24
            READ(NY,'(A9,A72)', END=10) DUM2(ND,H), Metdata(ND,H)
          END DO
          ND=ND+1

        END DO

 10     YDY(NY)=DY-1
        CLOSE(NY)

      END DO

***   Do 5-Year Loop - BY TOTAL NUMBER OF DAYS

      OPEN(31,FILE='YEAR1a.MET',STATUS='UNKNOWN')
      OPEN(32,FILE='YEAR2a.MET',STATUS='UNKNOWN')
      OPEN(33,FILE='YEAR3a.MET',STATUS='UNKNOWN')
      OPEN(34,FILE='YEAR4a.MET',STATUS='UNKNOWN')
      OPEN(35,FILE='YEAR5a.MET',STATUS='UNKNOWN')

** INITIALIZE TO FIRST YEAR **

      NY=31

** INITIALIZE DAY COUNTERS D1 & DD (FOR DATES) TO 1 **

      D1=1
      DD=1
      ND=ND-1

** CALL RANDOM SEED TO FIND D2 (FOR FIRST MET DATA DAY) **

      CALL RANDOM_SEED
      CALL RANDOM_NUMBER(X)
      D2=INT((ND)*X)+1

      WRITE(NY,'(A72)') DUM(NY)

      DO MD=1,ND

        DO H=1,24
          WRITE(NY,'(A9,A72)') DUM2(D1,H), Metdata(D2,H)
        END DO

        D1=D1+1
        DD=DD+1
        IF(DD .GT. YDY(NY)) THEN
          CLOSE(NY)
          DD=1
          NY=NY+1
          WRITE(NY,'(A72)') DUM(NY)
        END IF

        D2=D2+1
        IF(D2 .GT. ND) THEN
          D2=1
        END IF

      END DO

      STOP
      END
